#!/usr/bin/env python
# -*- coding: utf-8 -*-import socket

# Dataprobe ipIO-8 Get Status
# 
# Author: David Weiss dweiss@dataprobe.com
# Revision: Inital Release 1.2
# Date: 7/17/2009
#
# Summary:  ipIO-8  Get the status of Inputs and Outputs
# Requires one argument: <ipaddr> 
#
# <ipaddr>    IP Address of ipIO-8 unit
#

import sys
import re
import socket
import struct

ip = sys.argv[1]
pas ="P"
uid = "U"
p_pas = pas.ljust(21,'P')
p_uid = uid.ljust(21,'U')
hello = 'hello-000'+'\x00'
  
def ipFormatChk(ip_str): 
   pattern = r"\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b" 
   if re.match(pattern, ip_str): 
      return True 
   else: 
      return False
   
if not ipFormatChk(ip):
   err.append("IP Address Format Error")
    
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
port = 9100
try:
      s.connect((ip, port))
except socket.timeout, msg:
      print "Timeout Connecting to "
      print ip
      s.close()
      sys.exit(1)
except socket.error, msg:
      print "Error Connecting to "
      print ip
      s.close()
      sys.exit(1)
s.send(hello)
seq = s.recv(2)
value = struct.unpack("<h", seq)
seq1 = value[0]+1
seq1a = struct.pack("<h", seq1)
#                            |-- 01-control, 04-get relays, 06-get inputs
s.send('\x03'+p_uid+p_pas+'\x06\x00'+seq1a)
inp = s.recv(8)
seq2 = seq1+2
seq2a = struct.pack("<h", seq2)
s.send('\x03'+p_uid+p_pas+'\x04\x00'+seq2a)
rel = s.recv(8)
s.close()
#
relays = struct.unpack("8B", rel)
inputs = struct.unpack("8B", inp)
print "ipIO-8 at " + ip
print "Relays are: "
for i in range(len(relays)):
   stat = 'Open'
   if relays[i] == 1:
      stat = 'Closed'     
   num = i+1
   print num, stat
print "Inputs are: "
for i in range(len(inputs)):
   stat = 'Open'
   if inputs[i] == 1:
      stat = 'Closed' 
   num = i+1
   print num, stat